Broadcom wireless drivers failed to build [error: implicit declaration of function ‘init_timer’]

Bug #1757008 reported by Ben64
304
This bug affects 57 people
Affects Status Importance Assigned to Milestone
Broadcom 802.11 Linux STA driver
New
Undecided
Unassigned
bcmwl (Ubuntu)
Confirmed
Undecided
Unassigned
broadcom-sta (Ubuntu)
Confirmed
Undecided
Unassigned

Bug Description

The module fails to build, as it is missing the necessary patches for the latest HWE kernel.

/var/lib/dkms/bcmwl/6.30.223.271+bdcom/build/src/wl/sys/wl_linux.c: In function ‘wl_init_timer’:
/var/lib/dkms/bcmwl/6.30.223.271+bdcom/build/src/wl/sys/wl_linux.c:2359:2: error: implicit declaration of function ‘init_timer’ [-Werror=implicit-function-declaration]
  init_timer(&t->timer);
  ^

ProblemType: Package
DistroRelease: Ubuntu 16.04
Package: bcmwl-kernel-source 6.30.223.271+bdcom-0ubuntu1~1.2
ProcVersionSignature: Ubuntu 4.13.0-36.40~16.04.1-generic 4.13.13
Uname: Linux 4.13.0-36-generic x86_64
NonfreeKernelModules: wl
ApportVersion: 2.20.1-0ubuntu2.15
Architecture: amd64
DKMSKernelVersion: 4.15.0-13-generic
Date: Mon Mar 19 15:02:46 2018
DuplicateSignature: dkms:bcmwl-kernel-source:6.30.223.271+bdcom-0ubuntu1~1.2:/var/lib/dkms/bcmwl/6.30.223.271+bdcom/build/src/wl/sys/wl_linux.c:2359:2: error: implicit declaration of function ‘init_timer’ [-Werror=implicit-function-declaration]
InstallationDate: Installed on 2017-06-05 (287 days ago)
InstallationMedia: Ubuntu 16.04.2 LTS "Xenial Xerus" - Release amd64 (20170215.2)
PackageVersion: 6.30.223.271+bdcom-0ubuntu1~1.2
RelatedPackageVersions:
 dpkg 1.18.4ubuntu1.4
 apt 1.2.26
SourcePackage: bcmwl
Title: bcmwl-kernel-source 6.30.223.271+bdcom-0ubuntu1~1.2: bcmwl kernel module failed to build
UpgradeStatus: No upgrade log present (probably fresh install)

Revision history for this message
Ben64 (ben64) wrote :
tags: removed: need-duplicate-check
summary: bcmwl-kernel-source 6.30.223.271+bdcom-0ubuntu1~1.2: bcmwl kernel module
- failed to build
+ failed to build [error: implicit declaration of function ‘init_timer’]
Revision history for this message
Launchpad Janitor (janitor) wrote : Re: bcmwl-kernel-source 6.30.223.271+bdcom-0ubuntu1~1.2: bcmwl kernel module failed to build [error: implicit declaration of function ‘init_timer’]

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in bcmwl (Ubuntu):
status: New → Confirmed
Revision history for this message
Zhidani Ramadhan (zhidanr) wrote :

please help me!! wifi cannot unable to active because not in interfaces

Changed in bcmwl (Ubuntu):
assignee: nobody → Zhidani Ramadhan (zhidanr)
Changed in broadcom-sta (Ubuntu):
status: New → Confirmed
Changed in bcmwl (Ubuntu):
assignee: Zhidani Ramadhan (zhidanr) → nobody
tags: added: bionic
summary: - bcmwl-kernel-source 6.30.223.271+bdcom-0ubuntu1~1.2: bcmwl kernel module
- failed to build [error: implicit declaration of function ‘init_timer’]
+ bcmwl-kernel-source: bcmwl kernel module failed to build [error:
+ implicit declaration of function ‘init_timer’]
Revision history for this message
Vincent Ladeuil (vila) wrote : Re: bcmwl-kernel-source: bcmwl kernel module failed to build [error: implicit declaration of function ‘init_timer’]

Happened today after the upgrade, lost wifi :-/

Linux pump 4.15.0-24-generic #26~16.04.1-Ubuntu SMP Fri Jun 15 14:35:08 UTC 2018 x86_64 x86_64 x86_64 GNU/Linux

Revision history for this message
Vincent Ladeuil (vila) wrote :

Happened today after the upgrade, lost wifi :-/

Linux pump 4.15.0-24-generic #26~16.04.1-Ubuntu SMP Fri Jun 15 14:35:08 UTC 2018 x86_64 x86_64 x86_64 GNU/Linux

rebooting with an older kernel worked around the issue:

Linux pump 4.13.0-45-generic #50~16.04.1-Ubuntu SMP Wed May 30 11:18:27 UTC 2018 x86_64 x86_64 x86_64 GNU/Linux

Revision history for this message
Zhidani Ramadhan (zhidanr) wrote :

do i have to downgrade my kernel?

Revision history for this message
Zhidani Ramadhan (zhidanr) wrote : Re: [Bug 1757008] Re: bcmwl-kernel-source: bcmwl kernel module failed to build [error: implicit declaration of function ‘init_timer’]

do i have to downgrade my kernel?

On Mon, Jul 2, 2018 at 7:51 PM, Vincent Ladeuil <email address hidden>
wrote:

> Happened today after the upgrade, lost wifi :-/
>
> Linux pump 4.15.0-24-generic #26~16.04.1-Ubuntu SMP Fri Jun 15 14:35:08
> UTC 2018 x86_64 x86_64 x86_64 GNU/Linux
>
> rebooting with an older kernel worked around the issue:
>
> Linux pump 4.13.0-45-generic #50~16.04.1-Ubuntu SMP Wed May 30 11:18:27
> UTC 2018 x86_64 x86_64 x86_64 GNU/Linux
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1757008
>
> Title:
> bcmwl-kernel-source: bcmwl kernel module failed to build [error:
> implicit declaration of function ‘init_timer’]
>
> Status in bcmwl package in Ubuntu:
> Confirmed
> Status in broadcom-sta package in Ubuntu:
> Confirmed
>
> Bug description:
> The module fails to build, as it is missing the necessary patches for
> the latest HWE kernel.
>
> ProblemType: Package
> DistroRelease: Ubuntu 16.04
> Package: bcmwl-kernel-source 6.30.223.271+bdcom-0ubuntu1~1.2
> ProcVersionSignature: Ubuntu 4.13.0-36.40~16.04.1-generic 4.13.13
> Uname: Linux 4.13.0-36-generic x86_64
> NonfreeKernelModules: wl
> ApportVersion: 2.20.1-0ubuntu2.15
> Architecture: amd64
> DKMSKernelVersion: 4.15.0-13-generic
> Date: Mon Mar 19 15:02:46 2018
> DuplicateSignature: dkms:bcmwl-kernel-source:6.30.
> 223.271+bdcom-0ubuntu1~1.2:/var/lib/dkms/bcmwl/6.30.223.
> 271+bdcom/build/src/wl/sys/wl_linux.c:2359:2: error: implicit declaration
> of function ‘init_timer’ [-Werror=implicit-function-declaration]
> InstallationDate: Installed on 2017-06-05 (287 days ago)
> InstallationMedia: Ubuntu 16.04.2 LTS "Xenial Xerus" - Release amd64
> (20170215.2)
> PackageVersion: 6.30.223.271+bdcom-0ubuntu1~1.2
> RelatedPackageVersions:
> dpkg 1.18.4ubuntu1.4
> apt 1.2.26
> SourcePackage: bcmwl
> Title: bcmwl-kernel-source 6.30.223.271+bdcom-0ubuntu1~1.2: bcmwl
> kernel module failed to build
> UpgradeStatus: No upgrade log present (probably fresh install)
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ubuntu/+source/bcmwl/+bug/
> 1757008/+subscriptions
>

Revision history for this message
Pomco (ppomco) wrote : Re: bcmwl-kernel-source: bcmwl kernel module failed to build [error: implicit declaration of function ‘init_timer’]
Download full text (5.3 KiB)

Hi.

I'm redirected here from bug #1770029

When upgrading kernel to 4.15.0-24-generic I also had problem with my broadcom network card : lost wifi

So I try to reinstall broadcom-sta-dkms :

:~$ sudo apt-get install broadcom-sta-dkms
[...]
Préparation du dépaquetage de .../broadcom-sta-dkms_6.30.223.271-3~16.04.2_all.deb ...
Dépaquetage de broadcom-sta-dkms (6.30.223.271-3~16.04.2) ...
Paramétrage de broadcom-sta-dkms (6.30.223.271-3~16.04.2) ...
Loading new broadcom-sta-6.30.223.271 DKMS files...
Building only for 4.15.0-24-generic
Building initial module for 4.15.0-24-generic
ERROR: Cannot create report: [Errno 17] File exists: '/var/crash/broadcom-sta-dkms.0.crash'
Error! Bad return status for module build on kernel: 4.15.0-24-generic (x86_64)
Consult /var/lib/dkms/broadcom-sta/6.30.223.271/build/make.log for more information.

And then I take a look to the make.log file :

~$ cat /var/lib/dkms/broadcom-sta/6.30.223.271/build/make.log
DKMS make.log for broadcom-sta-6.30.223.271 for kernel 4.15.0-24-generic (x86_64)
mardi 3 juillet 2018, 11:16:00 (UTC+0200)
/bin/sh: 1: [: Illegal number:
/bin/sh: 1: [: Illegal number:
Wireless Extension is the only possible API for this kernel version
Using Wireless Extension API
KBUILD_NOPEDANTIC=1 make -C /lib/modules/4.15.0-24-generic/build M=`pwd`
make[1] : on entre dans le répertoire « /usr/src/linux-headers-4.15.0-24-generic »
CFG80211 API is prefered for this kernel version
Using CFG80211 API
Kernel architecture is X86_64
  CC [M] /var/lib/dkms/broadcom-sta/6.30.223.271/build/src/shared/linux_osl.o
/var/lib/dkms/broadcom-sta/6.30.223.271/build/src/shared/linux_osl.c: In function ‘osl_os_get_image_block’:
/var/lib/dkms/broadcom-sta/6.30.223.271/build/src/shared/linux_osl.c:1083:26: warning: passing argument 2 of ‘kernel_read’ makes pointer from integer without a cast [-Wint-conversion]
  rdlen = kernel_read(fp, fp->f_pos, buf, len);
                          ^
In file included from ./include/linux/huge_mm.h:7:0,
                 from ./include/linux/mm.h:463,
                 from /var/lib/dkms/broadcom-sta/6.30.223.271/build/src/include/linuxver.h:65,
                 from /var/lib/dkms/broadcom-sta/6.30.223.271/build/src/shared/linux_osl.c:25:
./include/linux/fs.h:2858:16: note: expected ‘void *’ but argument is of type ‘loff_t {aka long long int}’
 extern ssize_t kernel_read(struct file *, void *, size_t, loff_t *);
                ^
/var/lib/dkms/broadcom-sta/6.30.223.271/build/src/shared/linux_osl.c:1083:37: warning: passing argument 3 of ‘kernel_read’ makes integer from pointer without a cast [-Wint-conversion]
  rdlen = kernel_read(fp, fp->f_pos, buf, len);
                                     ^
In file included from ./include/linux/huge_mm.h:7:0,
                 from ./include/linux/mm.h:463,
                 from /var/lib/dkms/broadcom-sta/6.30.223.271/build/src/include/linuxver.h:65,
                 from /var/lib/dkms/broadcom-sta/6.30.223.271/build/src/shared/linux_osl.c:25:
./include/linux/fs.h:2858:16: note: expected ‘size_t {aka long unsigned int}’ but argument is of type ‘char *’
 extern ssize_t kernel_read(struct file *, void *, size_t, loff_t *);
                ^
/var/lib/dk...

Read more...

Revision history for this message
Marc Peña (pachulo) wrote :

The solution seems to be in the -proposed repo: https://bugs.launchpad.net/ubuntu/+source/broadcom-sta/+bug/1777444

Revision history for this message
Marc Peña (pachulo) wrote :

So, I've tried to install the package in proposed and WiFi is working OK with kernel 4.15.

Revision history for this message
Philip Cunningham (mcfilib) wrote :

The package in proposed fixed the issue for me too.

Revision history for this message
Sami Volotinen (leopardi) wrote :

Hi, how to fix this practically without compiling any code? Today i lost wlan and error message let me into this bug. Currently my laptop is a brick without wlan...

Revision history for this message
Stan Varlamov (stanubuntu) wrote :

@Sami: the compilation is done automatically by the installer. You can either plug in Ethernet or reboot and chose Advanced Ubuntu boot option, scroll down to the previous ver. of the Kernel (4.13) and boot with it normally to get the WiFi connection back. Then "See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed" - just a couple of steps that don't affect your overall system if you "Create the file /etc/apt/preferences.d/proposed-updates with this content:...". Then sudo apt-get update and sudo apt-get install broadcom-sta-dkms/xenial-proposed. This should successfully compile for both 4.13 and 4.15 kernels. Then reboot normally and forget about this incident till the kernel testing flow breaks again next year or whenever.

summary: - bcmwl-kernel-source: bcmwl kernel module failed to build [error:
- implicit declaration of function ‘init_timer’]
+ Broadcom wireless drivers failed to build [error: implicit declaration
+ of function ‘init_timer’]
description: updated
Revision history for this message
Sami Volotinen (leopardi) wrote :

Thank you @Stan! got it fixed!

Revision history for this message
Pomco (ppomco) wrote :

Thank you a lot: easily fixed with "apt-get update/upgrade" today. Good work !

Revision history for this message
Michael Thorp (lobsta) wrote :

Is there a fix for the bcmwl package? I see that the broadcom-sta seems to have had a fix but I can't see mention of bcmwl? Or am I missing something?

Revision history for this message
Vincent Ladeuil (vila) wrote :

Same here (broadcom-sta vs bcmwl).

Can a kind soul explains if one can be used instead of the other and why/how they differ ?

Revision history for this message
ScarySquirrel (coproc-sbcglobal) wrote :

  // , I have the same problem.

If you're looking for a fix, someone made a post on the Ubuntu stackexchange:

https://askubuntu.com/questions/1052403/how-can-i-fix-broadcom-driver-wifi-with-4-15-0-24-kernel-on-ubuntu-16-04

How do we end up with a patch that deploys a version of our wireless driver that's incompatible with our kernel?

Should we start being more careful with kernel upgrades to LTS?

Revision history for this message
ScarySquirrel (coproc-sbcglobal) wrote :

  // , Looks like there's an official fix that doesn't require drivers from Bionic here:

https://askubuntu.com/a/1052488/150944

Revision history for this message
Ufos92 (ufos92) wrote :
Revision history for this message
Ogier (jacqogier) wrote :

I installed Ubuntu 16.04 on a MacBook Pro

Revision history for this message
Andrew Vian (drewvian) wrote :

I ran into this bug with today's update to kernel 4.15.0-29. I had no problem previously using the 4.15.0-24 kernel. The bug reporter automatically directed me to this bug report. I see similar issues, where my wifi adapter seems to have disappeared. I have not yet tried the workaround.

The relevant part of the message:
Setting up linux-modules-extra-4.15.0-29-generic (4.15.0-29.31~16.04.1) ...
Setting up linux-image-generic-hwe-16.04 (4.15.0.29.51) ...
Setting up linux-headers-4.15.0-29 (4.15.0-29.31~16.04.1) ...
Setting up linux-headers-4.15.0-29-generic (4.15.0-29.31~16.04.1) ...
/etc/kernel/header_postinst.d/dkms:
Error! Bad return status for module build on kernel: 4.15.0-29-generic (x86_64)
Consult /var/lib/dkms/bcmwl/6.30.223.271+bdcom/build/make.log for more information.
Setting up linux-headers-generic-hwe-16.04 (4.15.0.29.51) ...
Setting up linux-generic-hwe-16.04 (4.15.0.29.51) ...
Processing triggers for linux-image-4.15.0-29-generic (4.15.0-29.31~16.04.1) ...
/etc/kernel/postinst.d/dkms:
ERROR: Cannot create report: [Errno 17] File exists: '/var/crash/bcmwl-kernel-source.0.crash'
Error! Bad return status for module build on kernel: 4.15.0-29-generic (x86_64)
Consult /var/lib/dkms/bcmwl/6.30.223.271+bdcom/build/make.log for more information.

Revision history for this message
Andrew Vian (drewvian) wrote :

After browsing through some of the previous links, the proposed fix for the bcmwl version successfully solved the problem.
Fix found here: https://bugs.launchpad.net/ubuntu/+source/bcmwl/+bug/1777646

Revision history for this message
Jeff Taffuri (jtaffuri) wrote : [Bug 1757008] Re: Broadcom wireless drivers failed to build [error: implicit declaration of function ‘init_timer’]

Hi Andrew,

4.15.0-29-generic upgrade did the same thing to my wifi adapter. My
connection settings still exist but no wifi capability at all.

Jeff

Revision history for this message
Melissa Rice (melissa-5) wrote :

Here is what worked for me to restore WiFi functionality...

1. Run Software & Udpates from the launcher. In the Developer Options tab, check the box for Pre-released updates. This will require your admin password and will update the cache.

2. Run Software Updater from the launcher. It will present you with lots of options of stuff to update. Because I did not want to beta test the whole proposed release at this moment, but just fix my WiFi, I unchecked all of the updates except the Broadcom wireless driver. Then I installed this update, which did not require a reboot.

3. I tested the WiFi by unplugging the internet cable and connecting to wireless, which worked. A reboot was not requested so I didn't reboot.

4. Run Software & Udpates from the launcher. In the Developer Options tab, uncheck the box for Pre-released updates. This will require your admin password, again. It will update the cache. I did this because I don't want to install any further updates from the Proposed (pre-release) repository, just the one I needed to make WiFi work again.

My computer is a very old Dell Inspiron with Ubuntu 16.04. The wireless was working until I updated the OS this morning and the update failed due to a Broadcom driver problem, as described in this post and also here: https://bugs.launchpad.net/ubuntu/+source/bcmwl/+bug/1777646. The above procedure corrected the problem without introducing any new problems. Thanks to everyone who contributed the fix! Much appreciated.

Revision history for this message
luislay (luislaycarvalho) wrote :

after latest update i lost wifi connection this mens im without INTERNET, how can this be possible and when can we have an update to fix it.

Revision history for this message
luislay (luislaycarvalho) wrote :

ok i did Run Software & Udpates from the launcher. In the Developer Options tab.

now it works,

tks for very important tip.

Revision history for this message
luislay (luislaycarvalho) wrote :

at this time ubuntu software store is limited so maybe they are doing something but now cant see my programs on the store

Revision history for this message
Rajdeep Majumder (majumder.rajdeep) wrote :
Download full text (3.3 KiB)

Hello,

I don't have even any network connection with the latest kernel
(4.*15*.0-24-generic)
. So what I am doing >> logging in the older kernel (4.*13*.0-45-generic)
and booting the Ubuntu 16.04 then only it is working.
I have tried several time the "Software and updates" from the menu but the
same situation.

Do someone have any software that I can download from the older kernel and
then login with the new kernel to install it. Because the on-line method
won't work from the new kernel system as because there is not Internet
connectivity (meaning neither wired LAN or WIFI )..

For reference here is the device details of *my *HP laptop n109tu red model

------------------------------------

*-network
       description: Wireless interface
       product: *BCM43142 802.11b/g/n*

  *-network
       description: Ethernet interface
       product: RTL8101/2/6E PCI Express Fast/Gigabit Ethernet controller
       vendor: Realtek Semiconductor Co., Ltd.

----------------------------------------

Thanks for your help,
Rajdeep Majumder

On Sun, Jul 22, 2018 at 1:12 PM, luislay <email address hidden> wrote:

> at this time ubuntu software store is limited so maybe they are doing
> something but now cant see my programs on the store
>
> --
> You received this bug notification because you are subscribed to a
> duplicate bug report (1779926).
> https://bugs.launchpad.net/bugs/1757008
>
> Title:
> Broadcom wireless drivers failed to build [error: implicit declaration
> of function ‘init_timer’]
>
> Status in Broadcom 802.11 Linux STA driver:
> New
> Status in bcmwl package in Ubuntu:
> Confirmed
> Status in broadcom-sta package in Ubuntu:
> Confirmed
>
> Bug description:
> The module fails to build, as it is missing the necessary patches for
> the latest HWE kernel.
>
> /var/lib/dkms/bcmwl/6.30.223.271+bdcom/build/src/wl/sys/wl_linux.c: In
> function ‘wl_init_timer’:
> /var/lib/dkms/bcmwl/6.30.223.271+bdcom/build/src/wl/sys/wl_linux.c:2359:2:
> error: implicit declaration of function ‘init_timer’
> [-Werror=implicit-function-declaration]
> init_timer(&t->timer);
> ^
>
> ProblemType: Package
> DistroRelease: Ubuntu 16.04
> Package: bcmwl-kernel-source 6.30.223.271+bdcom-0ubuntu1~1.2
> ProcVersionSignature: Ubuntu 4.13.0-36.40~16.04.1-generic 4.13.13
> Uname: Linux 4.13.0-36-generic x86_64
> NonfreeKernelModules: wl
> ApportVersion: 2.20.1-0ubuntu2.15
> Architecture: amd64
> DKMSKernelVersion: 4.15.0-13-generic
> Date: Mon Mar 19 15:02:46 2018
> DuplicateSignature: dkms:bcmwl-kernel-source:6.30.
> 223.271+bdcom-0ubuntu1~1.2:/var/lib/dkms/bcmwl/6.30.223.
> 271+bdcom/build/src/wl/sys/wl_linux.c:2359:2: error: implicit declaration
> of function ‘init_timer’ [-Werror=implicit-function-declaration]
> InstallationDate: Installed on 2017-06-05 (287 days ago)
> InstallationMedia: Ubuntu 16.04.2 LTS "Xenial Xerus" - Release amd64
> (20170215.2)
> PackageVersion: 6.30.223.271+bdcom-0ubuntu1~1.2
> RelatedPackageVersions:
> dpkg 1.18.4ubuntu1.4
> apt 1.2.26
> SourcePackage: bcmwl
> Title: bcmwl-kernel-source 6.30.223.271+bdcom-0ubuntu1~1.2: bcmwl
> kernel module failed to build
> UpgradeStatu...

Read more...

Revision history for this message
AlbertoDAU (davidavila147) wrote :

Same problem over here in an old DELL inspiron.
Thanks to Melissa's post (#25) it was solved.

Revision history for this message
golisp (golisp) wrote :

How much will take to mark package bcmwl-kernel-source/now 6.30.223.271+bdcom-0ubuntu1~1.3 as tested if it is fixing bug from March, please?

I believe, this bug will not be used to push into upgrade to 18.04. Or?

Revision history for this message
martinely95 (martinely95) wrote :

@Marc Peña (pachulo)
Thank you very much! The fix is really in: https://bugs.launchpad.net/ubuntu/+source/broadcom-sta/+bug/1777444?comments=all

Revision history for this message
Ufos92 (ufos92) wrote :
Revision history for this message
Bill (wadcock2) wrote :

on Ubuntu 16.04 LTS. Installed tightVNCViewer, now get this problem. Using usb wireless as old Dell broadband driver does not work. Dell M6300 laptop.

Revision history for this message
mami (t-ani) wrote :

sudo apt-get purge bcmwl-kernel-source
sudo apt-get install broadcom-sta-dkms

works for me as it was described in https://bugs.launchpad.net/ubuntu/+source/broadcom-sta/+bug/1777444?comments=all

tr (roadglidegeek)
Changed in broadcom-sta (Ubuntu):
status: Confirmed → Fix Released
Changed in bcmwl (Ubuntu):
status: Confirmed → Fix Released
Revision history for this message
Jarno Suni (jarnos) wrote :

In which versions of the packages the fix is released? Which release of Ubuntu?

Revision history for this message
fjgaude (tanzen) wrote :

It works starting with 4.15.0-33-generic, at
least it did for me.
frank

On 08/25/2018 09:05 AM, Jarno Suni wrote:
> In which versions of the packages the fix is released? Which release of
> Ubuntu?
>

Changed in bcmwl (Ubuntu):
status: Fix Released → Confirmed
Changed in broadcom-sta (Ubuntu):
status: Fix Released → Confirmed
Revision history for this message
SaleelKudchadker (skudchad) wrote :

I am still not able to see any networks on 4.15.0-36-generic.

To post a comment you must log in.
This report contains Public information  
Everyone can see this information.

Other bug subscribers